# MPI_Dist_graph_create

MPI_DIST_GRAPH_CREATE returns a handle to a new communicator to which the distributed graph topology information is attached.

## Synopsis

    int MPI_Dist_graph_create(MPI_Comm comm_old, int n, int sources[],
                              int degrees[], int destinations[], int weights[],
                              MPI_Info info, int reorder, MPI_Comm *comm_dist_graph)

## Input Parameters

comm_old
  input communicator (handle)
n
  number of source nodes for which this process specifies edges (non-negative integer)
sources
  array containing the n source nodes for which this process specifies edges (array of non-negative integers)
degrees
  array specifying the number of destinations for each source node in the source node array (array of non-negative integers)
destinations
  destination nodes for the source nodes in the source node array (array of non-negative integers)
weights
  weights for source to destination edges (array of non-negative integers)
info
  hints on optimization and interpretation of weights (handle)
reorder
  the process may be reordered (true) or not (false) (logical)

## Output Parameter

comm_dist_graph
  communicator with distributed graph topology added (handle)

## Thread and Interrupt Safety

This routine is thread-safe. This means that this routine may be safely used by multiple threads without the need for any user-provided thread locks. However, the routine is not interrupt safe. Typically, this is due to the use of memory allocation routines such as `malloc` or other non-MPICH runtime routines that are themselves not interrupt-safe.

## Notes for Fortran

All MPI routines in Fortran (except for `MPI_WTIME` and `MPI_WTICK`) have an additional argument `ierr` at the end of the argument list. `ierr` is an integer and has the same meaning as the return value of the routine in C. In Fortran, MPI routines are subroutines, and are invoked with the `call` statement.

All MPI objects (e.g., `MPI_Datatype`, `MPI_Comm`) are of type `INTEGER` in Fortran.

## Errors

All MPI routines (except `MPI_Wtime` and `MPI_Wtick`) return an error value; C routines as the value of the function and Fortran routines in the last argument. Before the value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job. The error handler may be changed with `MPI_Comm_set_errhandler` (for communicators), `MPI_File_set_errhandler` (for files), and `MPI_Win_set_errhandler` (for RMA windows). The MPI-1 routine `MPI_Errhandler_set` may be used but its use is deprecated. The predefined error handler `MPI_ERRORS_RETURN` may be used to cause error values to be returned. Note that MPI does not guarentee that an MPI program can continue past an error; however, MPI implementations will attempt to continue whenever possible.

MPI_SUCCESS
  No error; MPI routine completed successfully.

Location:dist_gr_create.c